<?php
namespace Module\Categories\Admin;
use Controller\AdminAct;
use Model\Model;

require_once(dirname(dirname(dirname(dirname(__FILE__)))) . '/Utils/functions.php');

class Act extends AdminAct {
	public function __construct($id) {
		//Permission needed for editing this type of entity
		$this->permission = 'Manage shop';
		//Table name
		$this->entity = new Model('categories');
        $act = false;
        //Check if user has access
        if ($this->hasAccess()) {
            //$id is needed for update and delete, it is set in constructor by the admin router
            if ($id) $this->fields['id'] = $id;
            //The methods are POST for create, PATCH for update and DELETE for delete
            if (strtolower($_SERVER['REQUEST_METHOD']) == 'delete') {
                $this->delete();
            }
            else {
                $method = 'patch';
                if (strtolower($_SERVER['REQUEST_METHOD']) == 'patch') {
                    //Set the global variable PATCH from the input
                    if ($id) parse_str(file_get_contents('php://input'), $_PATCH);
                    else $this->sendStatus(false, __('No ID set'));
                }
                else {
                    $method = 'create';
                }
                foreach ($method == 'patch' ? $_PATCH : $_POST AS $key => $value) $this->fields[$key] = $value;
                try {
                    $act = call_user_func_array(array($this, $method), array());
                }
                catch (\Exception $e) {
                    $this->sendStatus(false, $e->getMessage());
                }
            }
        }
        $this->sendStatus($act);
	}
}