<?php
namespace Module\Categories\Admin;

class AdminPage extends \Controller\AdminPage {
	public function output() {
		$page = new \stdClass();
		$page->title = __('Edit categories');
		$page->h1 = __('Edit categories');
        $page->js = array('js/combobox.js','../vendor/datatables/datatables/media/js/jquery.dataTables.min.js', '../vendor/datatables/datatables/media/js/dataTables.bootstrap4.min.js', 'js/jsall.js', 'Module/Categories/Admin/categories.js');
        $page->css = array('../vendor/datatables/datatables/media/css/jquery.dataTables.min.css', '../vendor/datatables/datatables/media/css/dataTables.bootstrap4.min.css', 'dataTables.fontawesome.css');
		$page->content = '<div class="box">
	<div class="box-header">
	    <div class="row">
			<div class="col-md-9"><h3 class="box-title">' . __('Edit categories') . '</h3></div>
			<div class="col-md-3">
				<a href="#" class="filter-datatable"><i class="fas fa-search"></i>' . __('Filters') . '</a>
			</div>
		</div>
	</div>
	<div class="box-body">
	    <div class="row">
			<div class="col-12">
				<table id="data_table" class="table table-borderless table-hover table-sm w-100">
					<thead class="thead-light">
						<tr><th data-filtertype="text" data-filterid="idf">#</th><th data-filtertype="text" data-filterid="parentf" data-autocomplete="category">' . __('Parent category') . '</th><th data-filtertype="text" data-filterid="namef">' . __('Name') . '</th><th>' . __('Date created') . '</th><th>' . __('Date updated') . '</th><th>' . __('Actions') . '</th></tr>
					</thead>
					<tbody>
					</tbody>
				</table>
			</div>
		</div>
	</div>
	<div class="box-footer">
		<div class="btn-toolbar">
			<button id="add" class="btn btn-outline-primary btn-sm"><i class="fas fa-plus"></i> ' . __('Add category') . '</button>
			<button class="btn btn-outline-secondary btn-export btn-sm" data-type="excel"><i class="fas fa-file-excel"></i> ' . __('Export to Excel') . '</button>
			<button class="btn btn-outline-secondary btn-export btn-sm" data-type="pdf"><i class="fas fa-file-pdf"></i> ' . __('Export to PDF') . '</button>
		</div>
	</div>
</div>
<div id="ppEdit" class="modal dialog fade">
	<div class="modal-dialog">
		<div class="modal-content">
			<div class="modal-header">
				<h4 class="modal-title">' . $page->title . '</h4>
				<button type="button" class="close" data-dismiss="modal" aria-label="' . __('Close') . '">
					<span aria-hidden="true">×</span>
				</button>
			</div>
			<div class="modal-body" id="edtable">
				<div class="form-group">
				    <div class="input-group">
                        <input type="text" class="ui-autocomplete-input form-control autocomplete-category" id="edparent_category" name="edparent_category" />
                        <label for="edparent_category" class="control-label">' . __('Parent category') . '</label>
                        <i class="bar"></i>
					</div>
                </div>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" class="form-control" id="edname" name="edname" required />
                        <label for="edname" class="control-label">' . __('Category name') . '</label>
                        <i class="bar"></i>
					</div>
                </div>
			</div>
			<div class="modal-footer">
				<button type="button" class="btn btn-default pull-left" data-dismiss="modal">' . __('Close') . '</button>
				<button type="button" class="btn btn-outline-primary" id="save">' . __('Save') . '</button>
			</div>
		</div>
	</div>
</div>';
		return $page;
	}
}