<?php
namespace Module\Categories\Admin;

use Model\Model;
use Module\JSON\Admin;

require_once(dirname(dirname(dirname(dirname(__FILE__)))) . '/Utils/functions.php');
class JSON extends Admin {
	public function __construct() {
		//Permission needed for retrieving this informations
		$this->permission = "Manage shop";
		//Columns used for exporting to Excel or PDF
		$this->columnsMap = array('id' => 'ID',
			'categories.name' => __('Parent category'),
			'name' => __('Category name'),
			'created' => __('Date created'),
			'updated' => __('Date updated')
		);
		//Instance name is the filename for exporting to Excel / PDF
		$this->instanceName = __('Categories');
		parent::__construct();
	}
	public function get() {
		if(!arrayKeyExists('id', $_REQUEST)) {
			$itemsPerPage = (arrayKeyExists('start', $_REQUEST))?$_REQUEST['length']:10;
			$limit = ((arrayKeyExists('start', $_REQUEST))?$_REQUEST['start']:0) . ', ' . $itemsPerPage;
			$categories = new Model('categories');
			if(!arrayKeyExists('cRecords', $_REQUEST)) $this->countTotal = $categories->countItems();
			if(arrayKeyExists('filters', $_REQUEST)) {
				foreach($_REQUEST['filters'] AS $key => $value) {
					//If the filter name is the category name we will use wildcard matching
					if(in_array($key, array('name'))) $categories->$key = array('%' . $value . '%', ' LIKE ');
					else $categories->$key = $value;
				}
			}
			if(!arrayKeyExists('cRecords', $_REQUEST)) $this->countFiltered = $categories->countItems();
			else {
				//If we want only to count the records
				$categories->addCustomField('COUNT(*) AS totalRecords');
				$ops = $categories->get('AND', true);
				$this->data = $ops;
				parent::output();
				exit;
			}
			//If we don't want to export the data then limit the select
			if(!arrayKeyExists('export', $_REQUEST)) $categories->limit($limit);
			$ops = $categories->get('AND', true);
			$this->data = $ops;
			$categories = array();
			//This is used for autocomplete category names
			if(!arrayKeyExists('secho', $_REQUEST)) {
				foreach($ops AS $category) $categories['#' . $category->id] = $category->name;
				$this->data = $categories;
			}
			parent::output();
		}
		else {
			$category = new Model('categories');
			$category = $category->getOneResult('id', $_REQUEST['id']);
			echo json_encode($category);
		}
	}
}