/*
variable 'jsonPage' is the name of the php file used for retrieving data from admin/json/{jsonPage}.php and
for updating / creating / deleting records by accesing the admin/act/{jsonPage}.php file

variable aoColumns define the dataTable (see https://datatables.net/) columns for the admin page

function loadData(aoData) build the filters for retrieving the json data
 */
var jsonPage = 'Categories',
	aoColumns = [
		{ "mData": "id" },
		{ "mData": "categories.name" },
		{ "mData": "name" },
		{ "mData": "created" },
		{ "mData": "updated" },
		{ "mData": function(e) {
			return "<span class=\"actions btn btn-outline-primary btn-outline-primary fas fa-edit\"></span><span class=\"actions btn btn-outline-danger fas fa-trash\" title=\"" + jsstrings.delete + "\" data-actid=\"" + e.id + "\" data-toggle=\"modal\" data-target=\"#confirm_delete\"></span>";
		} }
	],
	delAction = 'delete_category';
function loadData(aoData) {
	/* DO NOT MODIFY */
	var filters = {};
	$(aoData).each(function(i, val) {
		if(val.name == 'sEcho') filters.secho = val.value;
		else if(val.name == 'iDisplayStart') filters.start = val.value;
		else if(val.name == 'iDisplayLength') filters.length = val.value;
	});
	filters.filters = {};

	/* MODIFY ONLY THE FILTERS BELOW */
	if($("#idf").val()!='') filters.filters['id'] = $("#idf").val();
	if($("#parentf").data('ui-autocomplete') && $("#parentf").data('ui-autocomplete').hasOwnProperty('selectedItem') && $("#parentf").data('ui-autocomplete').selectedItem) filters.filters['parent_category'] = $("#parentf").data('ui-autocomplete').selectedItem.id;
	if($("#namef").val()!='') filters.filters['name'] = $("#namef").val();

	return filters;
}

$(function() {
	$.widget.bridge('uitooltip', $.ui.tooltip);
	$(".autocomplete-category").combobox({
		source: function(request, response) {
			var data = {};
			data.filters = {};
			data.filters.name = request.term;
			$.ajax({
				type: 'POST',
				url: 'json/Categories',
				data: data,
				jsonp: "callback",
				dataType: "jsonp",
				success: function(data) {
					response($.map(data, function(el, index) {
						var iddata = index.substring(1);
						return {
							value: el,
							id: iddata
						};
					}));
				}
			});
		},
		minLength: 2,
		change: function() {
			if($(this).closest('#data_table').length) datatableAjaxReload();
		}
	});
});