<?php
namespace Module\Categories;

use Controller\AdminController;
use Model\Model;
use Utils\Database;

class Setup extends \Module\Setup {
	public function __construct() {
		parent::__construct();
		$categoryTable = new Model('categories');
		//Check if table `categories` was found
		if(!count($categoryTable->schema)) {
			$sql = file_get_contents(dirname(__FILE__) . '/shop.sql');
			$db = Database::getInstance();
			$db->begin_transaction();
			$db->multi_query($sql);
			$db->commit();
			while(mysqli_more_results($db)) mysqli_next_result($db);
		}
		$permission = AdminController::registerPermission('Manage shop');
		//Add permission to administrator
		$administrator = new Model('admins');
		$administrator = $administrator->getOneResult('username', 'admin');
		$admin_permission = new Model('admins_permissions');
		$admin_permission->admin = $administrator->id;
		$admin_permission->permission = $permission->id;
		$admin_permission->create();
		$this->registerBackendUrl(array('permission' => 'Manage shop', 'url' => 'categories', 'menu_text' => 'Categories', 'menu_class' => 'fas fa-shopping-bag'));
		return true;
	}
}