<?php
namespace Module\Demo;
use Model\Model;
use \PHPThumb\GD;

class Page {
	public function output() {
		$bcrypt          = new \Utils\Bcrypt(10);
		$usersArray      = array(
			array(
				'firstname' => 'Bob',
				'lastname' => 'Fleming',
				'email' => 'bob.fleming@example.com',
				'phone' => '5524833823',
				'address' => 'Sample address bob',
				'city' => 'Chicago',
				'state' => 'Illinois',
				'country' => 'United States',
				'password' => 'bobfpassword',
				'status' => 1
			),
			array(
				'firstname' => 'Rowley',
				'lastname' => 'Birkin',
				'email' => 'rowley.birkin@example.com',
				'phone' => '552396314',
				'address' => 'Sample address rowley',
				'city' => 'Los Angeles',
				'state' => 'California',
				'country' => 'United States',
				'password' => 'rowleybpassword',
				'status' => 1
			),
			array(
				'firstname' => 'Louis',
				'lastname' => 'Balfour',
				'email' => 'louis.balfour@example.com',
				'phone' => '722963266',
				'address' => 'Sample address louis',
				'city' => 'Seattle',
				'state' => 'Washington',
				'country' => 'United States',
				'password' => 'louisbpassword',
				'status' => 1
			),
			array(
				'firstname' => 'Alex',
				'lastname' => 'Glavan',
				'email' => 'alex.glavan@example.com',
				'phone' => '0721234560',
				'address' => 'Sample address alex',
				'city' => 'Bucharest',
				'state' => 'Bucharest',
				'country' => 'Romania',
				'password' => 'alexgpassword',
				'status' => 1
			),
			array(
				'firstname' => 'John',
				'lastname' => 'Smith',
				'email' => 'john.smith@example.com',
				'phone' => '57452235',
				'address' => 'Sample address john smith',
				'city' => 'Houston',
				'state' => 'Texas',
				'country' => 'United States',
				'password' => 'johnspassword',
				'status' => 1
			),
			array(
				'firstname' => 'John',
				'lastname' => 'Doe',
				'email' => 'john.doe@example.com',
				'phone' => '34748568',
				'address' => 'Sample address john doe',
				'city' => 'Boston',
				'state' => 'Massachusetts',
				'country' => 'United States',
				'password' => 'johndpassword',
				'status' => 1
			)
		);
		$usersIds        = array();
		$countries       = array();
		$countriesEntity = new Model('countries');
		$countriesEntity = $countriesEntity->get();
		foreach ($countriesEntity AS $country)
			$countries[$country->name] = $country->id;

		//Create users from the usersArray
		$users = new Model('users');
		foreach ($usersArray AS $userArray) {
			$users->firstname = $userArray['firstname'];
			$users->lastname  = $userArray['lastname'];
			$users->email     = $userArray['email'];
			$users->phone     = $userArray['phone'];
			$users->address   = $userArray['address'];
			$users->city      = $userArray['city'];
			$users->state     = $userArray['state'];
			$users->country   = $countries[$userArray['country']];
			$users->password  = $bcrypt->hash($userArray['password']);
			$users->status    = $userArray['status'];
			$users->create();
			$usersIds[]       = $users->id;
			$users->clear();
		}

		//Create categories
		$categories                  = new Model('categories');
		//Create Laptops category
		$categories->parent_category = '0xNULL';
		$categories->name            = 'Laptops';
		$categories->create();
		$laptopsCategory = $categories->id;
		$categories->clear();
		//Create TV category
		$categories->parent_category = '0xNULL';
		$categories->name            = 'TV';
		$categories->create();
		$tvCategory = $categories->id;
		$categories->clear();
		//Create Gaming laptops category
		$categories->parent_category = $laptopsCategory;
		$categories->name            = 'Gaming laptops';
		$categories->create();
		$gamingLaptopsCategory = $categories->id;
		$categories->clear();
		//Create Business laptops category
		$categories->parent_category = $laptopsCategory;
		$categories->name            = 'Business laptops';
		$categories->create();
		$businessLaptopsCategory = $categories->id;
		$categories->clear();

		//Create products
		//Create first Asus gaming laptop
		$products              = new Model('products');
		$products->name        = 'Laptop ASUS Gaming 17.3" ROG GL752VW';
		$products->sku         = 'GL752VW';
		$products->description = 'Laptop ASUS Gaming 17.3" ROG GL752VW, FHD, Intel® Core™ i7-6700HQ (6M Cache, up to 3.50 GHz), 8GB DDR4, 1TB 7200 RPM, GeForce GTX 960M 4GB, Black';
		$products->price       = 1099.99;
		$products->stock       = 4;
		$products->sort_order  = 1;
		$products->url         = 'laptop_asus_gaming_17_3_rog_gl752vw';
		$products->create();
		$asus1 = $products->id;
		$products->clear();

		//Create second Asus gaming laptop
		$products->name        = 'Laptop ASUS Gaming 17.3" ROG STRIX GL702VM-DB71';
		$products->sku         = 'GL702VM-DB71';
		$products->description = 'Asus ROG Strix GL702VM-DB71 17.3-Inch. G-SYNC VR Ready Thin and Light Gaming Laptop (NVIDIA GTX 1060 6GB Intel Core i7-6700HQ 16GB DDR4 1TB 7200RPM HDD)';
		$products->price       = 1799.99;
		$products->stock       = 3;
		$products->sort_order  = 2;
		$products->url         = 'laptop_asus_gaming_17_3_rog_strix_gl702vm_db71';
		$products->create();
		$asus2 = $products->id;
		$products->clear();

		//Create Lenovo laptop; will be added in Gaming laptops category and Business laptops category
		$products->name        = 'Laptop Lenovo Thinkpad T470';
		$products->sku         = 'T470';
		$products->description = 'Laptop Lenovo ThinkPad T470';
		$products->price       = 919.99;
		$products->stock       = 5;
		$products->sort_order  = 1;
		$products->url         = 'laptop_lenovo_thinkpad_t470';
		$products->create();
		$lenovo = $products->id;
		$products->clear();

		//Create Acer business laptop
		$products->name        = 'Laptop Acer TravelMate P278';
		$products->sku         = 'TMP278-M-52UJ-US';
		$products->description = 'Lenovo Acer TravelMate P278';
		$products->price       = 856.99;
		$products->stock       = 8;
		$products->sort_order  = 2;
		$products->url         = 'laptop_acer_travelmate_p278';
		$products->create();
		$acer = $products->id;
		$products->clear();

		//Create Sony TV
		$products->name        = 'TV Sony Bravia 55" 2017';
		$products->sku         = 'XBR55X900E';
		$products->description = 'Sony XBR55X900E 55-Inch 4K Ultra HD Smart LED TV (2017 Model)';
		$products->price       = 1198.99;
		$products->stock       = 4;
		$products->sort_order  = 1;
		$products->url         = 'tv_sony_bravia_55_2017';
		$products->create();
		$sony = $products->id;
		$products->clear();

		//Add products into categories
		$category_products = new Model('category_products');

		//Add first Asus gaming laptop into Gaming laptops category
		$category_products->category = $gamingLaptopsCategory;
		$category_products->product  = $asus1;
		$category_products->create();
		$category_products->clear();

		//Add second Asus gaming laptop into Gaming laptops category
		$category_products->category = $gamingLaptopsCategory;
		$category_products->product  = $asus2;
		$category_products->create();
		$category_products->clear();

		//Add Lenovo laptop into Gaming laptops category and into Business laptops category
		$category_products->category = $gamingLaptopsCategory;
		$category_products->product  = $lenovo;
		$category_products->create();
		$category_products->clear();
		$category_products->category = $businessLaptopsCategory;
		$category_products->product  = $lenovo;
		$category_products->create();
		$category_products->clear();

		//Add Acer business laptop into Business laptops category
		$category_products->category = $businessLaptopsCategory;
		$category_products->product  = $acer;
		$category_products->create();
		$category_products->clear();

		//Add Sony TV into TV category
		$category_products->category = $tvCategory;
		$category_products->product  = $sony;
		$category_products->create();
		$category_products->clear();

		//Create product photos and add them to img folder

		$product_photos = new Model('product_photos');

		$filename = 'laptop_asus_gaming_17_3_rog_gl752vw-1.png';
		self::createProductImage($filename);
		$product_photos->product  = $asus1;
		$product_photos->filename  = $filename;
		$product_photos->create();
		$product_photos->clear();

		$filename = 'laptop_asus_gaming_17_3_rog_gl752vw-2.png';
		self::createProductImage($filename);
		$product_photos->product  = $asus1;
		$product_photos->filename  = $filename;
		$product_photos->create();
		$product_photos->clear();

		$filename = 'laptop_asus_gaming_17_3_rog_strix_gl702vm_db71-1.png';
		self::createProductImage($filename);
		$product_photos->product  = $asus2;
		$product_photos->filename  = $filename;
		$product_photos->create();
		$product_photos->clear();

		$filename = 'laptop_asus_gaming_17_3_rog_strix_gl702vm_db71-2.png';
		self::createProductImage($filename);
		$product_photos->product  = $asus2;
		$product_photos->filename  = $filename;
		$product_photos->create();
		$product_photos->clear();

		$filename = 'laptop_lenovo_thinkpad_t470-1.png';
		self::createProductImage($filename);
		$product_photos->product  = $lenovo;
		$product_photos->filename  = $filename;
		$product_photos->create();
		$product_photos->clear();

		$filename = 'laptop_lenovo_thinkpad_t470-2.png';
		self::createProductImage($filename);
		$product_photos->product  = $lenovo;
		$product_photos->filename  = $filename;
		$product_photos->create();
		$product_photos->clear();

		$filename = 'laptop_acer_travelmate_p278-1.png';
		self::createProductImage($filename);
		$product_photos->product  = $acer;
		$product_photos->filename  = $filename;
		$product_photos->create();
		$product_photos->clear();

		$filename = 'laptop_acer_travelmate_p278-2.png';
		self::createProductImage($filename);
		$product_photos->product  = $acer;
		$product_photos->filename  = $filename;
		$product_photos->create();
		$product_photos->clear();

		$filename = 'tv_sony_bravia_55_2017-1.png';
		self::createProductImage($filename);
		$product_photos->product  = $sony;
		$product_photos->filename  = $filename;
		$product_photos->create();
		$product_photos->clear();

		$filename = 'tv_sony_bravia_55_2017-2.png';
		self::createProductImage($filename);
		$product_photos->product  = $sony;
		$product_photos->filename  = $filename;
		$product_photos->create();
		$product_photos->clear();

		//Create orders
		$orders         = new Model('orders');
		$order_products = new Model('order_products');
		//For the first user we will create an order with the following products: Acer business laptop (qty: 2); Sony TV (qty: 1)
		$orders->status = 0 /* Status = Order created by user */ ;
		$orders->user   = $usersIds[0] /* First created user id*/ ;
		$orders->create();
		$order = $orders->id;
		$orders->clear();
		//Now we will add the products into the order
		$order_products->orderId  = $order;
		$order_products->product  = $acer;
		$order_products->quantity = 2;
		$order_products->price    = 809.99 /* He got a better price for the product at the moment of order */ ;
		$order_products->create();
		$order_products->clear();

		$order_products->orderId  = $order;
		$order_products->product  = $sony;
		$order_products->quantity = 1;
		$order_products->price    = 1198.99;
		$order_products->create();
		$order_products->clear();

		//For the second user we will create an order with the following products: first Asus gaming laptop (qty: 1)
		$orders->status = 1 /* Status = Processing by the store */ ;
		$orders->user   = $usersIds[1] /* Second created user id*/ ;
		$orders->create();
		$order = $orders->id;
		$orders->clear();
		//Now we will add the products into the order
		$order_products->orderId  = $order;
		$order_products->product  = $asus1;
		$order_products->quantity = 1;
		$order_products->price    = 1099.99;
		$order_products->create();
		$order_products->clear();

		//For the third user we will create an order with the following products: first Asus gaming laptop (qty: 1); second Asus gaming laptop (qty: 2)
		$orders->status = 2 /* Status = In delivery */ ;
		$orders->user   = $usersIds[2] /* Third created user id*/ ;
		$orders->create();
		$order = $orders->id;
		$orders->clear();
		//Now we will add the products into the order
		$order_products->orderId  = $order;
		$order_products->product  = $asus1;
		$order_products->quantity = 1;
		$order_products->price    = 1099.99;
		$order_products->create();
		$order_products->clear();

		$order_products->orderId  = $order;
		$order_products->product  = $asus2;
		$order_products->quantity = 2;
		$order_products->price    = 1799.99;
		$order_products->create();
		$order_products->clear();

		$page = new \stdClass();
		$page->title = __('Demo');
		$page->description = __('Demo');
		$page->h1 = __('Demo');
		$page->content = 'Data generated!';
		$page->js = array();
		$page->css = array();

		return $page;
	}
	private static function createProductImage($filename) {
		$moduleDirectory = realpath(dirname(__FILE__)) . '/';
		$productsImg = _APP_DIR_ . 'assets/img/products/';
		rename($moduleDirectory . $filename, $productsImg . $filename);
		$path_parts = pathinfo($productsImg . $filename);
		$fname = $path_parts['filename'];
		$extension = $path_parts['extension'];
		$destination_file = $productsImg . $filename;
		$thumb_file_name380 = $productsImg . $fname . '-380x460.' . $extension;
		$thumb_file_name760 = $productsImg . $fname . '-760x920.' . $extension;
		$thumb = new GD($destination_file);
		$thumb->resize(760, 920);
		$thumb->save($thumb_file_name760, $extension);
		$thumb->resize(380, 460);
		$thumb->save($thumb_file_name380, $extension);
	}
}