<?php
namespace Module\Orders\Admin;
use Controller\AdminAct;
use Controller\AdminController;
use Model\Model;

require_once(dirname(dirname(dirname(dirname(__FILE__)))) . '/Utils/functions.php');

class Act extends AdminAct {
    private $products = [];
    private $quantity = [];
    private $price = [];
	public function __construct($id) {
		//Permission needed for editing this type of entity
		$this->permission = 'Manage shop';
		//Database table name
		$this->entity = new Model('orders');

        $act = false;
        if ($this->hasAccess()) {
            if ($id) $this->fields['id'] = $id;
            if (strtolower($_SERVER['REQUEST_METHOD']) == 'delete') $this->delete();
            else {
                $method = 'patch';
                if (strtolower($_SERVER['REQUEST_METHOD']) == 'patch') {
                    if ($id) parse_str(file_get_contents('php://input'), $_PATCH);
                    else $this->sendStatus(false, __('No ID set'));
                }
                else $method = 'create';
                foreach ($method == 'patch' ? $_PATCH : $_POST AS $key => $value) {
                    if(in_array($key, array('user', 'status'))) $this->fields[$key] = $value;
                    elseif($key == 'product') $this->products = $value;
                    elseif($key == 'quantity') $this->quantity = $value;
                    elseif($key == 'price') $this->price = $value;
                }
                try {
                    $act = call_user_func_array(array($this, $method), array());
                }
                catch (\Exception $e) {
                    $this->sendStatus(false, $e->getMessage());
                }
            }
        }
        $this->sendStatus($act);
	}

    public function create() {
        $act = $this->entity->create();
        if(is_a($act, 'Model\Model')) {
            $this->fields['id'] = $act->id;
            $this->setOrderProducts();
        }
        return $act;
    }

    public function patch() {
        foreach ($this->fields AS $key => $value) $this->entity->$key = $value;
        $act = $this->entity->update();
        if(is_a($act, 'Model\Model')) $this->setOrderProducts(true);
        return $act;
    }

    private function setOrderProducts($isUpdate = false) {
        $order_products = new Model('order_products');
        //If we have an update for order we clear the products it has been before update
        if($isUpdate) {
            $order_products->orderId = $this->fields['id'];
            $order_products->delete();
        }
        //We set the products selected for the product
        $order_products->clear();
        foreach($this->products AS $index => $idProduct) {
            $order_products->orderId = $this->fields['id'];
            $order_products->product = $idProduct;
            $order_products->quantity = $this->quantity[$index];
            $order_products->price = $this->price[$index];
            $order_products->create();
            $order_products->clear();
        }
    }
}