<?php
namespace Module\Orders\Admin;

use Model\Model;
use Module\JSON\Admin;

require_once(dirname(dirname(dirname(dirname(__FILE__)))) . '/Utils/functions.php');
class JSON extends Admin {
	public function __construct() {
		//Permission needed for retrieving this informations
		$this->permission = "Manage shop";
		//Columns used for exporting to Excel or PDF
		$this->columnsMap = array('id' => 'ID',
			'status' => __('Status ID'),
			'user' => __('Customer ID'),
			'users.name' => __('Customer name'),
			'created' => __('Order date'),
			'updated' => __('Date updated')
		);
		//Instance name is the filename for exporting to Excel / PDF
		$this->instanceName = __('Orders');
		parent::__construct();
	}
	public function get() {
		if(!arrayKeyExists('id', $_REQUEST)) {
			$itemsPerPage = (arrayKeyExists('start', $_REQUEST))?$_REQUEST['length']:10;
			$limit = ((arrayKeyExists('start', $_REQUEST))?$_REQUEST['start']:0) . ', ' . $itemsPerPage;
			$orders = new Model('orders');
			if(!arrayKeyExists('cRecords', $_REQUEST)) $this->countTotal = $orders->countItems();
			if(arrayKeyExists('filters', $_REQUEST)) {
				foreach($_REQUEST['filters'] AS $key => $value) {
                    if(in_array($key, array('created', 'updated'))) {
                        if(is_array($value)) $orders->$key = array(
                            $value[0] . ' 00:00:00',
                            'BETWEEN',
                            $value[1] . ' 23:59:59'
                        );
                        else $orders->$key = null;
                    }
                    else $orders->$key = $value;
                }
			}
			if(!arrayKeyExists('cRecords', $_REQUEST)) $this->countFiltered = $orders->countItems();
			else {
				//If we want only to count the records
				$orders->addCustomField('COUNT(*) AS totalRecords');
				$ops = $orders->get('AND', true);
				$this->data = $ops;
				parent::output();
				exit;
			}
			//If we don't want to export the data then limit the select
			if(!arrayKeyExists('export', $_REQUEST)) $orders->limit($limit);
			$ops = $orders->get('AND', true);
			$this->data = $ops;
			parent::output();
		}
		else {
			$order = new Model('orders');
			$order = $order->getOneResult('id', $_REQUEST['id']);
			$products = new \Model\Model('order_products');
			$products->orderId = $_REQUEST['id'];
			$productsEntity = $products->get();
			$products = array();
			foreach($productsEntity AS $product) $products[] = array('id' => $product->products->id, 'name' => $product->products->name, 'sku' => $product->products->sku, 'description' => $product->products->description, 'price' => $product->price, 'quantity' => $product->quantity);
			$order->products = $products;
			echo json_encode($order);
		}
	}
}