/*
variable 'jsonPage' is the name of the php file used for retrieving data from admin/json/{jsonPage}.php and
for updating / creating / deleting records by accesing the admin/act/{jsonPage}.php file

variable aoColumns define the dataTable (see https://datatables.net/) columns for the admin page

function loadData(aoData) build the filters for retrieving the json data
 */
var jsonPage = 'Orders',
	aoColumns = [
		{ "mData": "id" },
		{ "mData": function(e) {
			return e.users.firstname + " " + e.users.lastname;
		} },
		{ "mData": "created" },
		{ "mData": "updated" },
		{ "mData": function() {
			return "<span class=\"actions btn btn-outline-primary btn-outline-primary fas fa-edit\"></span>";
		} }
	];
function loadData(aoData) {
	/* DO NOT MODIFY */
	var filters = {};
	$(aoData).each(function(i, val) {
		if(val.name == 'sEcho') filters.secho = val.value;
		else if(val.name == 'iDisplayStart') filters.start = val.value;
		else if(val.name == 'iDisplayLength') filters.length = val.value;
	});
	filters.filters = {};

	/* MODIFY ONLY THE FILTERS BELOW */
	if($("#idf").val()!='') filters.filters['id'] = $("#idf").val();
	if ($("#namef").data('ui-autocomplete') && $("#namef").data('ui-autocomplete').hasOwnProperty('selectedItem') && $("#namef").data('ui-autocomplete').selectedItem) filters.filters['user'] = $("#namef").data('ui-autocomplete').selectedItem.id;
	if($('#createdf').val() != '') {
		if($('#createdf').val() != 'Never') filters.filters['created'] = [$('#createdf').data('daterangepicker').startDate.format('YYYY-MM-DD'), $('#createdf').data('daterangepicker').endDate.format('YYYY-MM-DD')];
		else filters.filters['created'] = 0;
	}
	if($('#updatedf').val() != '') {
		if($('#updatedf').val() != 'Never') filters.filters['updated'] = [$('#updatedf').data('daterangepicker').startDate.format('YYYY-MM-DD'), $('#updatedf').data('daterangepicker').endDate.format('YYYY-MM-DD')];
		else filters.filters['updated'] = 0;
	}
	return filters;
}
function productCombobox(element) {
	element.combobox({
		source: function(request, response) {
			var data = {};
			data.filters = {};
			data.filters.name = request.term;
			$.ajax({
				type: 'POST',
				url: 'json/Products',
				data: data,
				jsonp: "callback",
				dataType: "jsonp",
				success: function(data) {
					response($.map(data, function(el, index) {
						var iddata = index.substring(1);
						return {
							value: el.name,
							id: iddata,
							description: el.sku,
							price: el.price
						};
					}));
				}
			});
		},
		minLength: 2,
		change: function(e, data) {
			if($(element).closest('#data_table').length) datatableAjaxReload();
		},
		select: function(e, data) {
			if($(element).closest('#edtable').length) $(element).closest('tr').find('[name="edprice[]"]').eq(0).val(data.item.price);
		}
	}).autocomplete("instance")._renderItem = function( ul, item ) {
		return $( "<li>" )
			.append( "<div>" + item.label + "<br /><span>" + item.description + "</span><em>" + item.price + "</em></div>" )
			.appendTo( ul );
	};
}
function addRow(item) {
	var ap = $('<input />'),
		pc = $('<input />'),
		qt = $('<input />'),
		apl = $('<label></label>'),
		pcl = $('<label></label>'),
		qtl = $('<label></label>'),
		ibar = $('<i></i>').addClass('bar'),
		addRowButton = $('<button></button>'),
		delRowButton = $('<button></button>'),
		pthead = $('#products').children('thead').eq(0).children('tr').eq(0),
		ptbody = $('#products').children('tbody').eq(0);
	addRowButton.addClass("btn btn-outline-primary btn-sm").append($("<i></i>").addClass("fas fa-plus"));
	delRowButton.addClass("btn btn-outline-danger btn-sm").append($("<i></i>").addClass("fas fa-minus"));
	addRowButton.click(function() {
		addRow();
	});
	delRowButton.click(function () {
		if(ptbody.children('tr').length > 1) $(this).closest('tr').remove();
	});
	ap.attr('type', 'text').attr('name', 'edproduct[]').addClass('ui-autocomplete-input form-control autocomplete-product');
	apl.addClass("control-label").text(pthead.children('th').eq(1).text());
	pc.attr("type", "number").attr("name", "edprice[]").attr('value', item?item.price:'0').attr('step', '0.01').addClass("form-control").val(item?item.price:'0');
	pcl.addClass("control-label").text(pthead.children('th').eq(2).text());
	qt.attr("type", "number").attr("name", "edquantity[]").attr('value', item?item.quantity:'1').addClass("form-control").val(item?item.quantity:'1');
	qtl.addClass("control-label").text(pthead.children('th').eq(3).text());
	productCombobox(ap);
	if(item) {
		ap.val(item.name);
		if (!ap.data('ui-autocomplete').hasOwnProperty('selectedItem') || !ap.data('ui-autocomplete').selectedItem) ap.data('ui-autocomplete').selectedItem = {id: item.id};
		else ap.data('ui-autocomplete').selectedItem.id = item.id;
	}
	ptbody.append($("<tr></tr>")
		.append($("<td></td>"))
		.append($("<td></td>").append($("<div></div>").addClass("form-group mb-0").append($("<div></div>").addClass("input-group").append(ap).append(apl).append(ibar.clone()))))
		.append($("<td></td>").append($("<div></div>").addClass("form-group mb-0").append($("<div></div>").addClass("input-group").append(pc).append(pcl).append(ibar.clone()))))
		.append($("<td></td>").append($("<div></div>").addClass("form-group mb-0").append($("<div></div>").addClass("input-group").append(qt).append(qtl).append(ibar.clone()))))
		.append($("<td></td>").append(addRowButton).append(delRowButton))
	);
}
//We define this function when we have objects in the json coming from editing object
function dataEdit(data) {
	var ptbody = $('#products').children('tbody').eq(0)
	$("#eduser").val(data.users.firstname + " " + data.users.lastname);
	ptbody.children('tr').remove();
	$.each(data.products, function(i, item) {
		addRow(item);
	});
}
$(function() {
	var ptbody = $('#products').children('tbody').eq(0);
	$.widget.bridge('uitooltip', $.ui.tooltip);
	$(".autocomplete-customer").combobox({
		source: function(request, response) {
			var data = {};
			data.filters = {};
			data.filters.name = request.term;
			$.ajax({
				type: 'POST',
				url: 'json/Users',
				data: data,
				jsonp: "callback",
				dataType: "jsonp",
				success: function(data) {
					response($.map(data, function(el, index) {
						var iddata = index.substring(1);
						return {
							value: el,
							id: iddata
						};
					}));
				}
			});
		},
		minLength: 2,
		change: function() {
			if($(this).closest('#data_table').length) datatableAjaxReload();
		}
	});
	$('body').on('click', 'span.actions.fa-edit,#add', function () {
		while(ptbody.children('tr').length > 1) ptbody.children('tr').last().remove();
	});
	addRow();
});