<?php
namespace Module\Products\Admin;
use Model\Model;
use Utils\Util;

class AdminPage extends \Controller\AdminPage {
	public function output() {
		$page = new \stdClass();
		$page->title = __('Edit products');
		$page->h1 = __('Edit products');
        $page->js = array('js/combobox.js','../vendor/datatables/datatables/media/js/jquery.dataTables.min.js', '../vendor/datatables/datatables/media/js/dataTables.bootstrap4.min.js', 'js/jsall.js', 'Module/Products/Admin/jquery.bootstrap.treeselect.js', 'Module/Products/Admin/products.js');
        $page->css = array('../vendor/datatables/datatables/media/css/jquery.dataTables.min.css', '../vendor/datatables/datatables/media/css/dataTables.bootstrap4.min.css', 'dataTables.fontawesome.css', 'Module/Products/Admin/jquery.bootstrap.treeselect.css', 'Module/Products/Admin/style.css');
		$categoriesOptions = [];
		$categories = new Model('categories');
		$categories = $categories->get();
		foreach($categories AS $category) {
			$parent = ($category->parent_category)?' data-parent="' . $category->parent_category . '"':'';
			$categoriesOptions[$category->id] = [$category->name, $parent];
		}
		$page->content = '<div class="box">
	<div class="box-header">
		<div class="row">
			<div class="col-md-9"><h3 class="box-title">' . __('Edit products') . '</h3></div>
			<div class="col-md-3">
				<a href="#" class="filter-datatable"><i class="fas fa-search"></i>' . __('Filters') . '</a>
			</div>
		</div>
	</div>
	<div class="box-body">
		<div class="row">
			<div class="col-12">
				<table id="data_table" class="table table-borderless table-hover table-sm w-100">
					<thead class="thead-light">
						<tr><th data-filtertype="text" data-filterid="idf">#</th><th data-filtertype="text" data-filterid="namef">' . __('Name') . '</th><th data-filtertype="text" data-filterid="skuf">' . __('SKU') . '</th><th>' . __('Price') . '</th><th>' . __('Actions') . '</th></tr>
					</thead>
					<tbody>
					</tbody>
				</table>
			</div>
		</div>
	</div>
	<div class="box-footer">
		<div class="btn-toolbar">
			<button id="add" class="btn btn-outline-primary btn-sm"><i class="fas fa-plus"></i> ' . __('Add product') . '</button>
			<button class="btn btn-outline-secondary btn-export btn-sm" data-type="excel"><i class="fas fa-file-excel"></i> ' . __('Export to Excel') . '</button>
			<button class="btn btn-outline-secondary btn-export btn-sm" data-type="pdf"><i class="fas fa-file-pdf"></i> ' . __('Export to PDF') . '</button>
		</div>
	</div>
</div>
<div id="ppEdit" class="modal dialog fade">
	<div class="modal-dialog">
		<div class="modal-content">
			<div class="modal-header">
				<h4 class="modal-title">' . $page->title . '</h4>
				<button type="button" class="close" data-dismiss="modal" aria-label="' . __('Close') . '">
					<span aria-hidden="true">×</span>
				</button>
			</div>
			<div class="modal-body" id="edtable">
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" class="form-control" id="edname" name="edname" required />
                        <label for="edname" class="control-label">' . __('Product name') . '</label>
                        <i class="bar"></i>
                    </div>
                </div>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" class="form-control" id="edsku" name="edsku" required />
                        <label for="edsku" class="control-label">' . __('SKU') . '</label>
                        <i class="bar"></i>
                    </div>
                </div>
                <div class="form-group">
                    <div class="input-group">
                        <textarea class="form-control" id="eddescription" name="eddescription" rows="3" cols="30"></textarea>
                        <label for="eddescription" class="control-label">' . __('Description') . '</label>
                        <i class="bar"></i>
                    </div>
                </div>
                <div class="form-group">
                    <div class="input-group">
                        <input type="number" class="form-control" id="edprice" name="edprice" step=".01" required />
                        <label for="edprice" class="control-label">' . __('Price') . '</label>
                        <i class="bar"></i>
                    </div>
                </div>
                <div class="form-group">
                    <div class="input-group">
                        <input type="number" class="form-control" id="edstock" name="edstock" required />
                        <label for="edstock" class="control-label">' . __('Stock') . '</label>
                        <i class="bar"></i>
                    </div>
                </div>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" class="form-control" id="edurl" name="edurl" required />
                        <label for="edurl" class="control-label">' . __('URL') . '</label>
                        <i class="bar"></i>
                    </div>
                </div>
                <div class="form-group">
                    <div class="input-group">
                        <select multiple="multiple" id="categories" name="categories" class="form-control">
                            ' . Util::arrayToOptions($categoriesOptions) . '
                        </select>
                        <label for="categories" class="control-label">' . __('Categories') . '</label>
                        <i class="bar"></i>
                    </div>
                </div>
                <div class="form-group">
					<ul id="media-list" class="clearfix">
						<li class="myupload">
							<span><i class="fa fa-plus" aria-hidden="true"></i><input type="file" id="picupload" class="picupload" multiple="" /></span>
						</li>
					</ul>
				</div>
			</div>
			<div class="modal-footer">
				<button type="button" class="btn btn-default pull-left" data-dismiss="modal">' . __('Close') . '</button>
				<button type="button" class="btn btn-outline-primary" id="save">' . __('Save') . '</button>
			</div>
		</div>
	</div>
</div>';
		return $page;
	}
}