<?php
namespace Module\Products\Admin;

use Model\Model;
use Module\JSON\Admin;

require_once(dirname(dirname(dirname(dirname(__FILE__)))) . '/Utils/functions.php');
class JSON extends Admin {
	public function __construct() {
		//Permission needed for retrieving this informations
		$this->permission = "Manage shop";
		//Columns used for exporting to Excel or PDF
		$this->columnsMap = array('id' => 'ID',
			'name' => __('Product name'),
			'sku' => __('SKU'),
			'description' => __('Description'),
			'price' => __('Price'),
			'stock' => __('Stock'),
			'created' => __('Date created'),
			'updated' => __('Date updated')
		);
		//Instance name is the filename for exporting to Excel / PDF
		$this->instanceName = __('Products');
		parent::__construct();
	}
	public function get() {
		if(!arrayKeyExists('id', $_REQUEST)) {
			$itemsPerPage = (arrayKeyExists('start', $_REQUEST))?$_REQUEST['length']:10;
			$limit = ((arrayKeyExists('start', $_REQUEST))?$_REQUEST['start']:0) . ', ' . $itemsPerPage;
			$products = new Model('products');
			if(!arrayKeyExists('cRecords', $_REQUEST)) $this->countTotal = $products->countItems();
			if(arrayKeyExists('filters', $_REQUEST)) {
				foreach($_REQUEST['filters'] AS $key => $value) {
					//If the filter name is the product name we will use wildcard matching
					if(in_array($key, array('name', 'sku'))) $products->$key = array('%' . $value . '%', ' LIKE ');
					else $products->$key = $value;
				}
			}
			if(!arrayKeyExists('cRecords', $_REQUEST)) $this->countFiltered = $products->countItems();
			else {
				//If we want only to count the records
				$products->addCustomField('COUNT(*) AS totalRecords');
				$ops = $products->get('AND', true);
				$this->data = $ops;
				parent::output();
				exit;
			}
			//If we don't want to export the data then limit the select
			if(!arrayKeyExists('export', $_REQUEST)) $products->limit($limit);
			$ops = $products->get('AND', true);
			$this->data = $ops;
			$products = array();
			//This is used for autocomplete product names
			if(!arrayKeyExists('secho', $_REQUEST)) {
				foreach($ops AS $product) $products['#' . $product->id] = array('name' => $product->name, 'sku' => $product->sku, 'price' => $product->price);
				$this->data = $products;
			}
			parent::output();
		}
		else {
			$product = new Model('products');
			$product = $product->getOneResult('id', $_REQUEST['id']);
			$category_products = new Model('category_products', array());
			$category_products->product = $product->id;
			$category_products = $category_products->get();
			$categories = array();
			foreach($category_products AS $category_product) $categories[] = $category_product->category;
			$product->categories = $categories;
			$product_photos = new Model('product_photos', array());
			$product_photos->product = $product->id;
			$product_photos = $product_photos->get();
			$photos = array();
			foreach($product_photos AS $product_photo) {
				$target_dir = _APP_DIR_ . 'assets/img/products/';
				$target_file = $target_dir . $product_photo->filename;
				$path_parts = pathinfo($target_file);
				$fname = $path_parts['filename'];
				$extension = $path_parts['extension'];
				$thumb_file_name = $fname . '-380x460.' . $extension;
				$targetThumbDir = _FOLDER_URL_ . 'img/products/';
				$photos[] = array('src' => $targetThumbDir . $thumb_file_name, 'image' => $product_photo->filename);
			}
			$product->photos = $photos;
			echo json_encode($product);
		}
	}
}