/*
 variable 'jsonPage' is the name of the php file used for retrieving data from admin/json/{jsonPage}.php and
 for updating / creating / deleting records by accesing the admin/act/{jsonPage}.php file

 variable aoColumns define the dataTable (see https://datatables.net/) columns for the admin page

 function loadData(aoData) build the filters for retrieving the json data
 */
var jsonPage = 'Products',
	aoColumns = [
		{"mData": "id"},
		{"mData": "name"},
		{"mData": "sku"},
		{"mData": "price"},
		{
			"mData": function (e) {
				return "<span class=\"actions btn btn-outline-primary btn-outline-primary fas fa-edit\"></span><span class=\"actions btn btn-outline-danger fas fa-trash\" title=\"" + jsstrings.delete + "\" data-actid=\"" + e.id + "\" data-toggle=\"modal\" data-target=\"#confirm_delete\"></span>";
			}
		}
	],
	delAction = 'delete_product';
function loadData(aoData) {
	/* DO NOT MODIFY */
	var filters = {};
	$(aoData).each(function (i, val) {
		if (val.name == 'sEcho') filters.secho = val.value;
		else if (val.name == 'iDisplayStart') filters.start = val.value;
		else if (val.name == 'iDisplayLength') filters.length = val.value;
	});
	filters.filters = {};

	/* MODIFY ONLY THE FILTERS BELOW */
	if ($("#idf").val() != '') filters.filters['id'] = $("#idf").val();
	if ($("#namef").val() != '') filters.filters['name'] = $("#namef").val();
	if ($("#skuf").val() != '') filters.filters['sku'] = $("#skuf").val();

	return filters;
}
//We define this function when we have objects in the json coming from editing object
function dataEdit(data) {
	$('[name="categories[]"]').each(function () {
		$(this).prop('checked', false).trigger('change');
	});
	$.each(data.categories, function (index, value) {
		$('[name="categories[]"][data-value="' + value + '"]').prop('checked', true).trigger('change');
	});
	$.each(data.photos, function (index, value) {
		addPhoto(value);
	});
}
function addPhoto(value) {
	var li = $("<li></li>");
	li.append($("<img />").attr("src", value.src))
		.append($("<div></div>").addClass("post-thumb")
			.append($("<div></div>").addClass("inner-post-thumb")
				.append($("<span></span>").addClass("remove-pic").data("src", value.image)
					.append($("<i></i>").addClass("fa fa-times").attr("aria-hidden", "true")
					)
				)
			)
		);
	$("#media-list").prepend(li);
}
$(function () {
	$('#categories').treeselect();
	$('body').on('change', '.picupload', function (event) {
		var formData = new FormData(),
			files = event.target.files,
			output = document.getElementById("media-list");
		for (var i = 0; i < files.length; i++) formData.append('edimage[]', files[i]);
		$.ajax({
			type: 'POST',
			url: 'act/Media',
			data: formData,
			cache: false,
			contentType: false,
			processData: false,
			dataType: 'json',
			success: function (data) {
				$.each(data, function(index, value) {
					addPhoto(value);
				});
			}
		});
	}).on('click', '.remove-pic', function () {
		var filename = $(this).data('src');
		$(this).parent().parent().parent().remove();
		$.post('act/Media', {clearImg: filename});
	}).on('click', '#add,span.actions.fa-edit', function () {
		$(".remove-pic").each(function() {
			$(this).parent().parent().parent().remove();
		});
	});
	$("#edname").change(function() {
		$("#edurl").val($(this).val().toLowerCase().replace(/[\W]/g, '_'));
	});
});