<?php
namespace Module\Products;
use Model\Model;
use Utils\Util;

class Page {
	public function output() {
		$currentUrl = Util::getCurrentUrl();
		$page = new \stdClass();
		$products = new Model('products');
		$target_dir = _APP_DIR_ . 'assets/img/products/';
		if($currentUrl == 'catalog') {
			$page->title = _APP_NAME_;
			$page->description = _APP_NAME_;
			$page->h1 = _APP_NAME_;
			$page->css = array('Module/Products/homepage.css');
			$page->content = '<div class="row row-eq-height products-grid">';
			$products->limit(12);
			$products = $products->get();
			foreach($products AS $index => $product) {
				$productPhotos = new Model('product_photos');
				$productPhotos->product = $product->id;
				$productPhotos = $productPhotos->get();
				if(!count($productPhotos)) $productPhoto = _FOLDER_URL_ . 'img/' . _LOGO_;
				else {
					$target_file = $target_dir . $productPhotos[0]->filename;
					$path_parts = pathinfo($target_file);
					$fname = $path_parts['filename'];
					$extension = $path_parts['extension'];
					$thumb_file_name = $fname . '-380x460.' . $extension;
					$targetThumbDir = _FOLDER_URL_ . 'img/products/';
					$productPhoto = $targetThumbDir . $thumb_file_name;
				}
				if($index && $index % 3 == 0) $page->content .= '</div>
				<div class="row row-eq-height products-grid">';
				$page->content .= '<div class="col-4">
						<div class="product">
							<h3><a href="' . $product->url . '">' . $product->name . '</a></h3>
							<div class="product-photo"><a href="' . $product->url . '"><img src="' . $productPhoto . '" alt="' . htmlentities($product->name) . '" /></a></div>
							<a href="' . $product->url . '"><span class="price">' . $product->price . ' $</span></a>
						</div>
					</div>';
			}
			if(count($products) && count($products) % 3 > 0) $page->content .= '</div>';
		}
		else {
			$product = $products->getOneResult('url', $currentUrl);
			if($product) {
				$page->title = $product->name;
				$page->description = $product->name;
				$page->h1 = $product->name;
				$productPhotos = new Model('product_photos');
				$productPhotos->product = $product->id;
				$productPhotos = $productPhotos->get();
				if(!count($productPhotos)) $productPhoto = _FOLDER_URL_ . 'img/' . _LOGO_;
				else {
					$target_file = $target_dir . $productPhotos[0]->filename;
					$path_parts = pathinfo($target_file);
					$fname = $path_parts['filename'];
					$extension = $path_parts['extension'];
					$thumb_file_name = $fname . '-380x460.' . $extension;
					$targetThumbDir = _FOLDER_URL_ . 'img/products/';
					$productPhoto = $targetThumbDir . $thumb_file_name;
				}
				$page->content = '<div class="row product-page">
				<div class="col-4 item-photo">
                    <img src="' . $productPhoto . '" alt="' . htmlentities($product->name) . '" />
                </div>
                <div class="col-8">
                    <h1>' . $product->name . '</h1>    
                    <h2>' . $product->sku . '</h5>
                    <h3>' . $product->price . ' $</h3>
                    <div class="section cart">
                        <h6 class="title-attr"><small>' . __('Quantity') . '</small></h6>                    
                        <div>
                            <div class="btn-minus"><i class="fa fa-minus" aria-hidden="true"></i></div>
                            <input id="quantity" name="quantity" value="1" />
                            <div class="btn-plus"><i class="fa fa-plus" aria-hidden="true"></i></div>
                        </div>
                        <div class="section addtocart">
							<button class="btn btn-success"><i class="fa fa-cart-plus" aria-hidden="true"></i> ' . __('Add to cart') . '</button>
						</div>
                    </div>
                </div>                              
        
                <div class="col-12">
                	' . $product->description . '
                </div>';
				$page->js = array('Module/Products/product_page.js');
				$page->css = array('Module/Products/product_page.css');
			}
		}
		return $page;
	}
}